/*
 * Didier JACQUEMART
 * 
 */
using System;

namespace clas03c_
{
	class MainClass
	{
		public static void Main(string[] args)
		{
			cl1 x1=new cl1(1, 2);
			x1.affiche();
			x1.visu();
			Console.WriteLine("CL1 ToString= "+x1.ToString());
			
			cl2 y1=new cl2(11, 12, 13);
			// affiche de y1 
			y1.affiche();
			// visu : la partie cl1 de y1
			y1.visu();
			
			y1.maj();
			y1.affiche();
			y1.visu();
			Console.WriteLine(y1.ToString());
					
		}
	}

	
	class cl1
	{
		// doivent etre accessibles aux classes drives
		protected int _var1;
		protected int _var2;
			
		// constructeur
		public cl1(int p1, int p2)
		{
		_var1=p1;
		_var2=p2;
		}
		
		public int var1
		{
			set
			{
			_var1=value;	
			}
		}
		public int var2
		{
			set
			{
			_var2=value;	
			}
		}
		
		// sera surcharge dans la classe drive
		public virtual void affiche()
		{
			Console.WriteLine("CL1 : "+this._var1.ToString()+" / "+this._var2.ToString());
		}
		
		// sera hrite
		public void visu()
		{
			Console.WriteLine("CL1 Visu: "+this._var1.ToString()+" / "+this._var2.ToString());
		}

	}

	class cl2 : cl1 
	{
		private int _var3;
	
		// invoque automatiquement le constructeur de cl1
		// si pas base ..., le constructeur std de cl1
		// (sans parametre) est appel : il faut alors le dfinir
		public cl2(int p1, int p2, int p3) : base(p1, p2)
		{
			_var3=p3;
		}
		
		public int var3
		{
			set
			{
			_var3=value;	
			}
		}
		
		// surcharge de cl1
		public override void affiche()
		{
			Console.WriteLine("CL2 : "+this._var1.ToString()+" / "+this._var2.ToString()+" / "+this._var3.ToString());
		}
		
		public void maj()
		{
			_var1++;
			_var2--;
			_var3*=2;
		}
	
		public override string ToString()
		{
			return ("CL2 ToString= "+this._var1.ToString());
		}

	
	}

}
