/*
 * Didier JACQUEMART
 * 06/03/2005
 */
using System;
using System.Drawing;
using System.Windows.Forms;

namespace econom
{
	//<summary>
	//Affichage alatoire de courbes mathmatiques
	//Rptition infinie jusqu' double clic
	//</summary>

	#region Dfinition des variables gnrales et cinmatique
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Timers.Timer timer1;

		// Variables gnrales
		int taille;
		Form frm;
		PictureBox objpict;
		double xt;
		double xtde;
		double xta;
		double xtpas;
		int delai;
		int poshaut;
		int posgauche;
		double tca, tcc, tce, tcg;

		public MainForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			//
			// TODO: Add constructor code after the InitializeComponent() call.
			// ajout des vnements non grs en standard
			
			this.pictureBox1.DoubleClick += new System.EventHandler(this.PictureBox1DoubleClick);
			this.DoubleClick += new System.EventHandler(this.FormDoubleClick);
			frm=this;

			//
		}
		
		[STAThread]
		
		public static void Main(string[] args)
		{
			Application.Run(new MainForm());
		}
		#endregion
		
		#region Windows Forms Designer generated code
		/// <summary>
		/// This method is required for Windows Forms designer support.
		/// Do not change the method contents inside the source code editor. The Forms designer might
		/// not be able to load this method if it was changed manually.
		/// </summary>
		private void InitializeComponent() {
			this.timer1 = new System.Timers.Timer();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			((System.ComponentModel.ISupportInitialize)(this.timer1)).BeginInit();
			this.SuspendLayout();
			// 
			// timer1
			// 
			this.timer1.SynchronizingObject = this;
			this.timer1.Elapsed += new System.Timers.ElapsedEventHandler(this.Timer1Elapsed);
			// 
			// pictureBox1
			// 
			this.pictureBox1.Location = new System.Drawing.Point(72, 80);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(136, 72);
			this.pictureBox1.TabIndex = 0;
			this.pictureBox1.TabStop = false;
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.Add(this.pictureBox1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None;
			this.Name = "MainForm";
			this.Text = "MainForm";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.Load += new System.EventHandler(this.MainFormLoad);
			((System.ComponentModel.ISupportInitialize)(this.timer1)).EndInit();
			this.ResumeLayout(false);
		}
		#endregion
		
		#region Initialisation de l'cran
		// ***********************************************
		//	Initialisation du formulaire       
		// ***********************************************
		void MainFormLoad(object sender, System.EventArgs e)
		{
	 	 	// Caractristiques de l'cran
	 	 	frm.Height = 600;
    		frm.Width = 800;
    		frm.BackColor = Color.FromArgb(255,0,0,0);

    		// limites de la variable T
    		xtde = 0;
    		xta = 25;
    		xtpas = 0.001;
    
    		// intervalle de temps du timer (en ms)
    		delai = 1000;
    		
    		affiche_graphes();
			
		}
		#endregion
		
		#region Boucle principale
		// ***********************************************
		//	Boucle principale d'affichage       
		// ***********************************************
		void affiche_graphes() 
		{
		// tirer au hasard une combinaison de coefficients
	    int iformules;
    	Random xrnd=new Random();
    	iformules=xrnd.Next(53247, 99999+53247)-53247;
    
		// tracer le graphe ...
   		objpict = pictureBox1;
    	affiche_un_graphe (iformules);
		
    	// ... puis patienter pour le suivant
    	if (delai!=0)
			{
    	    timer1.Interval = delai;
        	timer1.Enabled = true;
			}	
		}	
		#endregion
		
		#region Traitement d'un graphe
		// ***********************************************
		//	Calcul et affichage d'un graphe
		// ***********************************************
	
		void affiche_un_graphe( int i)
		{

			
		// dcoder le n de combinaison
		//    (1er car. = coeff. tca : 1=0,5 2=1, ...)
		//    (5  car. = choix de la formule : sin ou exp)
		string iform =  (i+100000).ToString();

		tca = (double) ("0123456789".IndexOf(iform.Substring(1,1),0))/2;
		tcc = (double) ("0123456789".IndexOf(iform.Substring(2,1),0))/2;
		tce = (double) ("0123456789".IndexOf(iform.Substring(3,1),0)+1)/2;
		tcg = (double) ("0123456789".IndexOf(iform.Substring(4,1),0))/2;
		int igraph="0123456789".IndexOf(iform.Substring(5,1),0);

		// taille de la zone de trac
    	Random xrnd=new Random();
    	taille=350+xrnd.Next(0, 150);

		// position haute
		int    ind = 0;
		while (ind < 10) 
			{
			ind++;
			xrnd=new Random();
			poshaut=(int) (xrnd.Next(0, 100)*frm.Height/100);
			if ((poshaut + taille) <= frm.Height) 
				{
					ind = 99;
				}
			}
		if (ind==10) {poshaut=0;}


		// position gauche
	    ind = 0;
    	while (ind < 10) 
    		{
        	ind++;
			xrnd=new Random();
			posgauche=(int) (xrnd.Next(0, 100)*frm.Width/100);

			if ((posgauche + taille) <= frm.Width) { ind = 99;}
			}
    	if (ind==10) {posgauche=0;}

		//initialisation du trac
		
		// masquer la zone de dessin
		objpict.Visible=false;
		// la positionner
		objpict.Left=posgauche;
		objpict.Top=poshaut;
		objpict.Width=taille;
		objpict.Height=taille;
		// dfinir la zone graphique, la couleur, ...
		Bitmap bm = new Bitmap(objpict.Width, objpict.Height);
		Graphics g = Graphics.FromImage(bm);
		Color cc = Color.FromArgb(frm.BackColor.ToArgb());
		g.Clear(cc);
		
		// afficher la combinaison utilise
		Font ff=frm.Font;
		Brush bb=new SolidBrush(Color.White);

		g.DrawString(i.ToString(), ff, bb, (float) 0, (float) 0);

		// choix de la couleur du graphe
		xrnd=new Random();
		Color cfore=Color.FromArgb(255, xrnd.Next(0, 255),xrnd.Next(0, 255),xrnd.Next(0, 255));
		Pen pp=new Pen(cfore);

		// coordonnes des lignes  tracer
		int X1 = -1;
		int Y1 = -1;
		int X0 = taille / 2;
		int Y0 = taille / 2;
		int X2, Y2;

		// rayon maxi de la courbe
		int r0;
		if (igraph < 5) 
			{
			r0 = (int) ((taille - 10) / (2 * 2.8));
			}
		else 
			{
			r0 = (int) ((taille - 10) / (2 * 1));
			}

		// Calcul du pas de progression
		switch (igraph) 
			{
			case 3: xtpas=0.05; break;
			case 4: xtpas=0.05; break;
			case 8: xtpas=0.05; break;
			case 9: xtpas=0.05; break;
			default: xtpas=0.001; break;
			}

		// tracer tous les points
		for (xt=xtde; xt<=xta; xt+=xtpas) 
			{
			// point de fin
			if (igraph < 5)
				{
    			X2 =(int) ( (Math.Cos(tca * xt) * Math.Exp(Math.Cos(tcc * xt))) * r0 + X0);
    			Y2 =(int) ( Y0 - (Math.Sin(tce * xt) * Math.Exp(Math.Cos(tcg * xt))) * r0);
    			}
    		else 
    			{
    			X2 =(int) ( (Math.Cos(tca * xt) * (Math.Sin(tcc * xt))) * r0 + X0);
    			Y2 =(int) ( Y0 - (Math.Sin(tce * xt) * (Math.Cos(tcg * xt))) * r0);
			    }

			// dessin des lignes 
			//   . soit par rapport au centre du graphe
			//	 . soit par rapport au point prcdent
			
			switch(igraph) 
				{
				case 3: g.DrawLine(pp, X0, Y0, X2, Y2);
						break;
				case 4: g.DrawLine(pp, X0, Y0, X2, Y2);
						break;
				case 8: g.DrawLine(pp, X0, Y0, X2, Y2);
						break;
				case 9: g.DrawLine(pp, X0, Y0, X2, Y2);
						break;
				default: 
						if (X1 != -1) 
							{
							g.DrawLine(pp, X1, Y1, X2, Y2);
							}
						break;	
				}

			// dcaler les points pour le suivant
			X1 = X2;
        	Y1 = Y2;
			}
	
		// afficher le graphe
		objpict.Image = bm;
		objpict.Visible=true;
	
		}
		#endregion
	
		#region Evnements timer et double-clic
		// ***********************************************
		//	Traitement du timer
		// ***********************************************
		void Timer1Elapsed(object sender, System.Timers.ElapsedEventArgs e)
		{
			timer1.Enabled = false;
			affiche_graphes();
		}
		
		// ***********************************************
		//	Traitement du double-clic sur l'image
		// ***********************************************
		void PictureBox1DoubleClick(object sender, System.EventArgs e)
		{
			Close();
			
		}
		// ***********************************************
		//	Traitement du double-clic sur l'image
		// ***********************************************
		void FormDoubleClick(object sender, System.EventArgs e)
		{
			Close();
		}		
		#endregion
	
	}
}
