/*
 * Didier JACQUEMART
 * 
 */
using System;
using System.Drawing;
using System.Windows.Forms;
using System.IO;
	

namespace file01c_
{
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		string chemin, fic, nomfic;
		
		public MainForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			//
			// TODO: Add constructor code after the InitializeComponent() call.
			//
		}
		
		[STAThread]
		public static void Main(string[] args)
		{
			Application.Run(new MainForm());
		}
		
		#region Windows Forms Designer generated code
		/// <summary>
		/// This method is required for Windows Forms designer support.
		/// Do not change the method contents inside the source code editor. The Forms designer might
		/// not be able to load this method if it was changed manually.
		/// </summary>
		private void InitializeComponent() {
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.button1 = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// saveFileDialog1
			// 
			this.saveFileDialog1.DefaultExt = "*.txt";
			this.saveFileDialog1.Filter = "Fichiers texte (*.txt)|*.txt";
			this.saveFileDialog1.Title = "Fichier  crer";
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(136, 16);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(112, 48);
			this.button1.TabIndex = 0;
			this.button1.Text = "Lancer";
			this.button1.Click += new System.EventHandler(this.Button1Click);
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Tahoma", 18F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.World);
			this.label1.ForeColor = System.Drawing.Color.Red;
			this.label1.Location = new System.Drawing.Point(32, 112);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(232, 80);
			this.label1.TabIndex = 1;
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.button1);
			this.Name = "MainForm";
			this.Text = "MainForm";
			this.ResumeLayout(false);
		}
		#endregion
		void Button1Click(object sender, System.EventArgs e)
		{
			// Ouverture de la boite de dialogue de sauvegarde
			chemin=Environment.CurrentDirectory+"\\..\\..\\fichiers";
			saveFileDialog1.InitialDirectory=chemin;
			saveFileDialog1.ShowDialog();
			fic=saveFileDialog1.FileName;
			if (fic == "") {
				return;
			}
			nomfic=Path.GetFileNameWithoutExtension(fic);

			// ouvrir le fichier en sortie
			FileStream sb=new FileStream(fic, FileMode.Create);
			StreamWriter sw = new StreamWriter(sb);
		
            sw.Write("Ligne num");
            sw.WriteLine("ro 1");
            sw.WriteLine("Ligne 2");
            sw.WriteLine("Fin ... provisoire");
            sw.Close();

            // ouvrir en ajout
            StreamWriter swa = new StreamWriter(fic, true);
            swa.WriteLine("Nouvelle ligne");
            swa.Close();
			
            // lire le fichier ligne par ligne
            StreamReader sr = new StreamReader(fic);
            int nblig = 0;
            while (sr.ReadLine() != null) 
                {
				nblig++;				
				}
            label1.Text="Le fichier "+nomfic+"\ncontient "+nblig.ToString()+" lignes";
            sr.Close();
            
            FileInfo fi=new FileInfo(fic);

            // lecture en une fois
            sr=fi.OpenText();
            MessageBox.Show( sr.ReadToEnd(),"Dtail des lignes");
            sr.Close(); // il faut fermer sinon le fichier est toujours verrouill
                        
            // info sur le fichier
            MessageBox.Show("Taille : "+fi.Length.ToString());
           
            // ajout d'une nouvelle ligne
            sw=fi.AppendText();
            sw.WriteLine("Fin");
            sw.Close();
            
            // actualiser les infos
            fi.Refresh();
            MessageBox.Show("Nouvelle taille : "+fi.Length.ToString());
            
            // copier le fichier
            string temp;
            temp=fic.Replace(".txt", ".sav");
            fi.CopyTo(temp, true);
            
            // ouvrir le fichier en binaire
            FileStream fs = new FileStream(fic, FileMode.Open, FileAccess.ReadWrite);

            BinaryReader br=new BinaryReader(fs);
            fs.Seek(6, 0); // a partir de 0
            MessageBox.Show(br.ReadChar().ToString());
            MessageBox.Show(br.ReadChar().ToString());
            
            fs.Seek(6, 0);
            BinaryWriter bw=new BinaryWriter(fs);
            MessageBox.Show("R-criture N");
            bw.Write( "N".ToCharArray());
            MessageBox.Show(br.ReadChar().ToString());
            
	}
}
}
