/*
 * Didier JACQUEMART
 * 
 */
using System;
using System.Drawing;
using System.Windows.Forms;
using Microsoft.Win32;

namespace registry01c_
{
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		public MainForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			//
			// TODO: Add constructor code after the InitializeComponent() call.
			//
		}
		
		[STAThread]
		public static void Main(string[] args)
		{
			Application.Run(new MainForm());
		}
		
		#region Windows Forms Designer generated code
		/// <summary>
		/// This method is required for Windows Forms designer support.
		/// Do not change the method contents inside the source code editor. The Forms designer might
		/// not be able to load this method if it was changed manually.
		/// </summary>
		private void InitializeComponent() {
			this.button2 = new System.Windows.Forms.Button();
			this.button1 = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(24, 96);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(144, 48);
			this.button2.TabIndex = 1;
			this.button2.Text = "Lecture-criture hkcu/essai";
			this.button2.Click += new System.EventHandler(this.Button2Click);
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(24, 24);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(144, 48);
			this.button1.TabIndex = 0;
			this.button1.Text = "qui suis je ?";
			this.button1.Click += new System.EventHandler(this.Button1Click);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.button1);
			this.Name = "MainForm";
			this.Text = "MainForm";
			this.ResumeLayout(false);
		}
		#endregion
		void Button1Click(object sender, System.EventArgs e)
		{
			RegistryKey rk1 = Registry.LocalMachine;
			RegistryKey xmachinek=rk1.OpenSubKey("SYSTEM\\CurrentControlSet\\Control\\ComputerName\\ComputerName");
			string xmachine=xmachinek.GetValue("ComputerName").ToString();

			string xutil = Environment.ExpandEnvironmentVariables("%USERNAME%");
			MessageBox.Show("Bonjour "+xutil+"\nsur le systme "+xmachine);
			
		}
		
		void Button2Click(object sender, System.EventArgs e)
		{
			RegistryKey rk1 = Registry.CurrentUser;
			RegistryKey rk2;
			
			// supprimer la cl (et ses sous-cls) si elle existe
			rk2=rk1.OpenSubKey("essai");
			if (rk2!=null)
			{
					rk1.DeleteSubKeyTree("essai");
			}
			
			// crer la cl (elle est donc en criture)
			rk2 = rk1.CreateSubKey("essai");
			
			// crer diffrentes valeurs
			rk2.SetValue("chaine", "ma chaine");
			rk2.SetValue("dword", 0x12345678);
			rk2.SetValue("dword2", 123);
			
			byte [] tbin={0x01, 2, 3, 0x04, 5, 6};
			rk2.SetValue("bin", tbin);
			
			rk2.SetValue("a supprimer", "a supprimer");
			
			rk2.Close();
			
			// rouvrir en criture explicitement
			rk2=rk1.OpenSubKey("essai", true);
			
			string [] tstr={"aaa", "bbb", "ccc"};
			rk2.SetValue("chaine multi", tstr);
			
			rk2.CreateSubKey("sous-cl");
			rk2.CreateSubKey("sous-cl 2");
			rk2.DeleteValue("a supprimer");
			
			// lister les sous-cls et valeurs
			string txt="La cl essai contient ";
			txt=txt+rk2.SubKeyCount.ToString();
			txt+=" sous-cls :\n";
			foreach(string cle in rk2.GetSubKeyNames())
			{
				txt+="   "+cle+"\n";	
			}
			txt+="\net "+rk2.ValueCount.ToString()+" valeurs :";
			
			// liste des valeurs
			txt+="\n";
			
			foreach(string val in rk2.GetValueNames())
			{
				string donnee=rk2.GetValue(val).ToString();
				string dontyp=rk2.GetValue(val).GetType().ToString();
				txt+="   "+val+" ("+dontyp+") ";
				int typedonnee=0;
				if (dontyp.CompareTo("System.Byte[]")==0){typedonnee=1;}
				if (dontyp.CompareTo("System.String[]")==0){typedonnee=2;}
				switch (typedonnee)
				{
				case 0:
					txt+="= "+donnee+"\n";
					break;
				case 1:
					txt+="= ";
					byte [] tbinlec={};
					tbinlec=(byte [])rk2.GetValue(val);
					for (int i=0; i<tbinlec.Length;i++)
					{
						txt+=tbinlec[i].ToString()+" ";
					}
					txt+="\n";
					break;
					
				case 2:
					txt+="= ";
					string [] tstrlec={};
					tstrlec=(string [])rk2.GetValue(val);
					for (int i=0; i<tstrlec.Length;i++)
					{
						txt+=tstrlec[i].ToString()+" ";
					}
					txt+="\n";
					break;

				}
			}
			MessageBox.Show(txt);
			
		}
			}
}
