/*
 * Didier JACQUEMART
 * 
 */
using System;
using System.Drawing;
using System.Windows.Forms;
using System.Data.OleDb;
using System.IO;


namespace treeview01c_
{
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TreeView tv1;
		private System.Windows.Forms.Button btexport;
		private System.Windows.Forms.Button btsuiv;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button btauteurs;
		private System.Windows.Forms.Button btprec;
		private System.Windows.Forms.Button btexpand;
		private System.Windows.Forms.StatusBar sb1;
		
		enum expansion { Fermer_Tout = 1, Ouvrir_Tout };
		private expansion indexpand;
		private TreeNode tnrac;
		
		public MainForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			//
			// TODO: Add constructor code after the InitializeComponent() call.
			//
		}
		
		[STAThread]
		public static void Main(string[] args)
		{
			Application.Run(new MainForm());
		}
		
		#region Windows Forms Designer generated code
		/// <summary>
		/// This method is required for Windows Forms designer support.
		/// Do not change the method contents inside the source code editor. The Forms designer might
		/// not be able to load this method if it was changed manually.
		/// </summary>
		private void InitializeComponent() {
			this.sb1 = new System.Windows.Forms.StatusBar();
			this.btexpand = new System.Windows.Forms.Button();
			this.btprec = new System.Windows.Forms.Button();
			this.btauteurs = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.btsuiv = new System.Windows.Forms.Button();
			this.btexport = new System.Windows.Forms.Button();
			this.tv1 = new System.Windows.Forms.TreeView();
			this.SuspendLayout();
			// 
			// sb1
			// 
			this.sb1.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.World);
			this.sb1.Location = new System.Drawing.Point(0, 262);
			this.sb1.Name = "sb1";
			this.sb1.Size = new System.Drawing.Size(408, 40);
			this.sb1.TabIndex = 3;
			this.sb1.Text = "statusBar1";
			// 
			// btexpand
			// 
			this.btexpand.Location = new System.Drawing.Point(320, 56);
			this.btexpand.Name = "btexpand";
			this.btexpand.Size = new System.Drawing.Size(80, 32);
			this.btexpand.TabIndex = 2;
			this.btexpand.Text = "btexpand";
			this.btexpand.Click += new System.EventHandler(this.BtexpandClick);
			// 
			// btprec
			// 
			this.btprec.Location = new System.Drawing.Point(320, 136);
			this.btprec.Name = "btprec";
			this.btprec.Size = new System.Drawing.Size(80, 32);
			this.btprec.TabIndex = 5;
			this.btprec.Text = "&Prcdent";
			this.btprec.Click += new System.EventHandler(this.BtprecClick);
			// 
			// btauteurs
			// 
			this.btauteurs.Location = new System.Drawing.Point(320, 216);
			this.btauteurs.Name = "btauteurs";
			this.btauteurs.Size = new System.Drawing.Size(80, 32);
			this.btauteurs.TabIndex = 7;
			this.btauteurs.Text = "Auteurs";
			this.btauteurs.Click += new System.EventHandler(this.BtauteursClick);
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Arial", 24F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.World);
			this.label1.ForeColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(128)), ((System.Byte)(255)));
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(392, 40);
			this.label1.TabIndex = 0;
			this.label1.Text = "Bibliothque";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// btsuiv
			// 
			this.btsuiv.Location = new System.Drawing.Point(320, 96);
			this.btsuiv.Name = "btsuiv";
			this.btsuiv.Size = new System.Drawing.Size(80, 32);
			this.btsuiv.TabIndex = 4;
			this.btsuiv.Text = "&Suivant";
			this.btsuiv.Click += new System.EventHandler(this.BtsuivClick);
			// 
			// btexport
			// 
			this.btexport.Location = new System.Drawing.Point(320, 176);
			this.btexport.Name = "btexport";
			this.btexport.Size = new System.Drawing.Size(80, 32);
			this.btexport.TabIndex = 6;
			this.btexport.Text = "Exporter";
			this.btexport.Click += new System.EventHandler(this.BtexportClick);
			// 
			// tv1
			// 
			this.tv1.BackColor = System.Drawing.SystemColors.Window;
			this.tv1.CheckBoxes = true;
			this.tv1.FullRowSelect = true;
			this.tv1.HideSelection = false;
			this.tv1.ImageIndex = -1;
			this.tv1.Location = new System.Drawing.Point(8, 56);
			this.tv1.Name = "tv1";
			this.tv1.SelectedImageIndex = -1;
			this.tv1.Size = new System.Drawing.Size(304, 200);
			this.tv1.TabIndex = 1;
			this.tv1.AfterCheck += new System.Windows.Forms.TreeViewEventHandler(this.Tv1AfterCheck);
			this.tv1.DoubleClick += new System.EventHandler(this.Tv1DoubleClick);
			this.tv1.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.Tv1AfterSelect);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(408, 302);
			this.Controls.Add(this.btauteurs);
			this.Controls.Add(this.btexport);
			this.Controls.Add(this.btprec);
			this.Controls.Add(this.btsuiv);
			this.Controls.Add(this.sb1);
			this.Controls.Add(this.tv1);
			this.Controls.Add(this.btexpand);
			this.Controls.Add(this.label1);
			this.Name = "MainForm";
			this.Text = "MainForm";
			this.Load += new System.EventHandler(this.MainFormLoad);
			this.ResumeLayout(false);
		}
		#endregion
		// *****   INITIALISATION DU PROGRAMME 
		void MainFormLoad(object sender, System.EventArgs e)
		{
			charge_livres();
			sb1.Text="";
			indexpand=expansion.Fermer_Tout;
			toggle_expand();
		}
	
		// *****   CHARGEMENT DU TREEVIEW
		private void charge_livres()
		{
			string xxx;
						
			// Connexion base access (1 par datareader)
			OleDbConnection cnn = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data source=..\\..\\bibli.mdb");
			cnn.Open();
			OleDbConnection cnnl = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data source=..\\..\\bibli.mdb");
			cnnl.Open();
			
			// Dfinition des readers pour auteurs et livres
			OleDbCommand cmdaut = cnn.CreateCommand();
			cmdaut.CommandText = "select * from aut order by autdir";
			OleDbDataReader rdraut = cmdaut.ExecuteReader();
			OleDbCommand cmdliv = cnnl.CreateCommand();

			// raz du tree view avec un noeud racine
			tv1.Nodes.Clear();
			tnrac=new TreeNode("La bibliothque par auteur");
			tnrac.Tag="Racine";
			tv1.Nodes.Add(tnrac);
			
			// lecture des auteurs
			while (rdraut.Read()) {
				// lecture
				xxx=rdraut["autnum"].ToString();
				int xautnum=int.Parse(xxx);
				string xautdir=rdraut["autdir"].ToString();
				string xautnom=rdraut["autnom"].ToString();

				// crer le noeud avec code A+N dans le tag
				TreeNode tnaut=new TreeNode();
				tnaut.Text=xautdir+ " - "+xautnom;
				tnaut.Tag="A"+xautnum.ToString();
				tnrac.Nodes.Add(tnaut);
				
				// livres de l'auteur
				cmdliv.CommandText = "select * from liv where livaut="+xautnum.ToString()+" order by livtit";
				OleDbDataReader rdrliv = cmdliv.ExecuteReader();
				
				while (rdrliv.Read()) {
					// lecture
					xxx=rdrliv["livnum"].ToString();
					int xlivnum=int.Parse(xxx);
					string xlivtit=rdrliv["livtit"].ToString();

					// crer le noeud pour le livre avec tag=L + n livre
					TreeNode tnliv=new TreeNode();
					tnliv.Text=xlivtit;
					tnliv.Tag="L"+xlivnum.ToString();
					tnaut.Nodes.Add(tnliv);
				}
				rdrliv.Close();
			}

			cnn.Close();
			cnnl.Close();
			
		}
		
		
		// *****   SELECTION D'UN NOEUD
		//	-> afficher le nombre de livres
		void Tv1AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			// Pour un auteur, afficher le nombre de livres
			string stag=tv1.SelectedNode.Tag.ToString();
			if (stag.StartsWith("A"))
			{
				// nombre de livres = nbe de noeuds fils
				int inb=tv1.SelectedNode.Nodes.Count;
				// extraire le nom de l'auteur DIR - Nom
				string snom=tv1.SelectedNode.Text;
				string delimStr = "-";
 				char [] delimiter = delimStr.ToCharArray();
		        string [] split = null;
		        // ... deuxime terme
		        split = snom.Split(delimiter, 2);
	
		        if (inb==0) 
	    	    {
	        		sb1.Text="Vous n'avez aucun livre de "+split[1];
		        }	
		        else
	    	    {
	        		sb1.Text="Vous avez "+inb.ToString()+" livre(s) de "+split[1];
	        	}
			
			}

			// pour la bibliothque, compter le nombre total de livres
			if (stag.StartsWith("R"))
			{
				int inbt=0;
				TreeNode tnauteurs=new TreeNode();
				tnauteurs=tnrac.FirstNode;
				while (tnauteurs !=null)
				{
					inbt+=tnauteurs.Nodes.Count;
					tnauteurs=tnauteurs.NextNode;
				}
		        if (inbt==0) 
	    	    {
	        		sb1.Text="Votre bibliothque est VIDE !!!";
		        }	
		        else
	    	    {
	        		sb1.Text=String.Format("Votre bibliothque contient {0} livre(s)", inbt);
		        }
			
			}
			}

		// *****   TRAITEMENT DU BOUTON BASCULE OUVRIR/FERMER TOUT
		void toggle_expand()
		{
			if (indexpand==expansion.Fermer_Tout)
			// fermer
			{
				tv1.CollapseAll();
				indexpand=expansion.Ouvrir_Tout;
			}
			else
			// ouvrir
			{
				tv1.ExpandAll();
				indexpand=expansion.Fermer_Tout;
			}
			// texte du bouton pour prochaine utilisation
			btexpand.Text=indexpand.ToString();

			// se repositionner au debut, sur le 1er auteur de la racine
			tv1.SelectedNode=tnrac.FirstNode;
			tnrac.EnsureVisible();
		}

		
		// *****   BOUTON SUIVANT : SELECTONNER NOEUD SUIVANT 
		void BtsuivClick(object sender, System.EventArgs e)
		{
			TreeNode tnselect=new TreeNode();
			TreeNode tnnouv=new TreeNode();
			tnselect=tv1.SelectedNode;
			if (tnselect !=null)
			{
				tnnouv=tnselect.NextNode;
				if (tnnouv!=null)
				{
					tnnouv.Expand();
					tv1.SelectedNode=tnnouv;
				}
			}
	}
		
		
		// *****   BOUTON PRECEDENT : SELECTONNER NOEUD PRECEDENT 
		void BtprecClick(object sender, System.EventArgs e)
		{
			TreeNode tnselect=new TreeNode();
			TreeNode tnnouv=new TreeNode();
			tnselect=tv1.SelectedNode;
			if (tnselect !=null)
			{
				tnnouv=tnselect.PrevNode;
				if (tnnouv!=null)
				{
					tnnouv.Expand();
					tv1.SelectedNode=tnnouv;
				}
			}
	
		}
		
		// *****   BOUTON "Fermer/Ouvrir"
		void BtexpandClick(object sender, System.EventArgs e)
		{
			toggle_expand();
		}
		
		// *****   TRAITEMENT CASE A COCHER
		void Tv1AfterCheck(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			TreeNode tncheck=new TreeNode();
			TreeNode tncheck2=new TreeNode();
			// noeud reprsentant la case coche/dcoche
			tncheck=e.Node;
			string stag=tncheck.Tag.ToString();
			// Racine ou auteur (A, R)
			if (!stag.StartsWith("L"))
			{
				//  lire les fils
				tncheck2=tncheck.FirstNode;
				while (tncheck2 !=null)
				{
					// recopier l'tat de la coche
					tncheck2.Checked=tncheck.Checked;
					tncheck2=tncheck2.NextNode;
				}
			}
		}
		
		
		// *****   EXPORTER LES LIVRES COCHES
		void BtexportClick(object sender, System.EventArgs e)
		{
			TreeNode tnaut=new TreeNode();
			TreeNode tnliv=new TreeNode();
			// ouvrir fichier de sortie
			FileStream sb=new FileStream("..\\..\\export.txt", FileMode.Create);
			StreamWriter sw = new StreamWriter(sb);

			// dbut du treeview
			tnaut=tnrac.FirstNode;
			while (tnaut !=null)
				{
					// dbut de l'auteur
					tnliv=tnaut.FirstNode;
					while (tnliv != null)
					{
						// si livre coch
						if (tnliv.Checked==true)
						{
							string xtit=tnliv.Text;
							string xaut=tnaut.Text;
							sw.WriteLine("{0}{1}",xpad(xaut, 30), xpad(xtit, 50));
						}	
						tnliv=tnliv.NextNode;
					}
					tnaut=tnaut.NextNode;
				}	
			sw.Close();
		}

		// formatage de chaine  une longueur fixe
		private string xpad(string ps, int pl)
		{
			string xxx=ps;
			string xx2=xxx.PadRight(pl);
			return xx2.Substring(0, pl);
		}
		
		// *****   APPEL MISE A JOUR LIVRE PAR DOUBLE-CLIC
		void Tv1DoubleClick(object sender, System.EventArgs e)
		{
			TreeNode tndbl=tv1.SelectedNode;
			string xtag=tndbl.Tag.ToString();
			string xtit;
			
			if (xtag.StartsWith("L"))
			{
				// activer le formulaire de maj avec passage de paramtres
				frmliv f= new frmliv();
				f.ShowDialog(xtag, out xtit);
				// si maj valide ...
				if (f.DialogResult==DialogResult.OK)
				{
					tndbl.Text=xtit;
				}
			}
		}
		
		void BtauteursClick(object sender, System.EventArgs e)
		{
			frmaut.Form1 f=new frmaut.Form1();
			f.ShowDialog();
			
			
		}
		
	}
		
}

