/*
 * Didier JACQUEMART
 * 
 */
using System;
using System.Drawing;
using System.Windows.Forms;
using System.ComponentModel;

namespace bibctl
{
	/// <summary>
	/// Description of UserControl1.	
	/// </summary>
	/// 

	public class UserControl1 : System.Windows.Forms.UserControl
	{
		private System.Windows.Forms.PictureBox pictureBox1;
		private int _valeur;
		
		public UserControl1()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			//
			// TODO: Add constructor code after the InitializeComponent() call.
			_valeur=50;
			
			//
		}
		
		#region Windows Forms Designer generated code
		/// <summary>
		/// This method is required for Windows Forms designer support.
		/// Do not change the method contents inside the source code editor. The Forms designer might
		/// not be able to load this method if it was changed manually.
		/// </summary>
		private void InitializeComponent() {
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.SuspendLayout();
			// 
			// pictureBox1
			// 
			this.pictureBox1.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(192)), ((System.Byte)(255)));
			this.pictureBox1.Location = new System.Drawing.Point(24, 32);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(208, 104);
			this.pictureBox1.TabIndex = 0;
			this.pictureBox1.TabStop = false;
			// 
			// UserControl1
			// 
			this.BackColor = System.Drawing.SystemColors.Control;
			this.Controls.Add(this.pictureBox1);
			this.Name = "UserControl1";
			this.Size = new System.Drawing.Size(292, 266);
			this.Resize += new System.EventHandler(this.UserControl1Resize);
			this.BackColorChanged += new System.EventHandler(this.UserControl1Bc);
			this.ResumeLayout(false);
		}
		#endregion
		void UserControl1Resize(object sender, System.EventArgs e)
		{
			// en utilisation du controle, redimensionner 
			//  la largeur choisie  l'cran, ce qui donne
			// en permanence une forme carre
			
			pictureBox1.Height= (int) (this.Size.Width*0.95);
			pictureBox1.Width=pictureBox1.Height; 
			pictureBox1.Left=(int) ((this.Size.Width-pictureBox1.Width)/2);
			pictureBox1.Top=pictureBox1.Left;
			this.SetClientSizeCore(this.Size.Width, this.Size.Width);
			
		}
		

		void UserControl1Bc(object sender, System.EventArgs e)
		{// evenement sur la couleur du controle
			pictureBox1.BackColor=this.BackColor;
		}

		// modification de la valeur -> redessiner le graphe
		public int valeur
		{
			set 
			{
			this._valeur=value;
			dessine();
			}
		}
		
		// dessin du graphe 
		private void dessine()
		{
			int x=pictureBox1.Width-2;
			int y=x;
			int ang=_valeur*360/100;
			Color coul_util=Color.FromArgb(255,255,0,0);
			Color coul_libr=Color.FromArgb(255,0,255,0);
			
			Bitmap bm = new Bitmap(pictureBox1.Width, pictureBox1.Height);
			Graphics g = Graphics.FromImage(bm);
			g.FillPie(new SolidBrush(coul_util), 0, 0, x, x, 270, ang);
			g.FillPie(new SolidBrush(coul_libr), 0, 0, x, x, 270, ang-360);
			
			pictureBox1.Image=bm;
		}
}
}
