/*
 * Didier JACQUEMART
 * 
 */
using System;
using System.Drawing;
using System.Windows.Forms;
using System.IO;
using System.Collections;
using System.Management;

namespace userctl01
{
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private bibctl.UserControl1 userControl11;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.ListBox listBox1;
		private bibctl.UserControl1 userControl12;

		// tableaux pour les lecteurs
		private string[] tlect=new string[10];
		private double[] tfree=new double[10];
		private double[] ttotal=new double[10];
		private string[] tvolume=new string[10];
		private int indlect=0;
		
		public MainForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			//
			// TODO: Add constructor code after the InitializeComponent() call.
			//
		}
		
		[STAThread]
		public static void Main(string[] args)
		{
			Application.Run(new MainForm());
		}
		
		#region Windows Forms Designer generated code
		/// <summary>
		/// This method is required for Windows Forms designer support.
		/// Do not change the method contents inside the source code editor. The Forms designer might
		/// not be able to load this method if it was changed manually.
		/// </summary>
		private void InitializeComponent() {
			this.userControl12 = new bibctl.UserControl1();
			this.listBox1 = new System.Windows.Forms.ListBox();
			this.label2 = new System.Windows.Forms.Label();
			this.userControl11 = new bibctl.UserControl1();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// userControl12
			// 
			this.userControl12.BackColor = System.Drawing.SystemColors.Control;
			this.userControl12.Location = new System.Drawing.Point(232, 56);
			this.userControl12.Name = "userControl12";
			this.userControl12.Size = new System.Drawing.Size(112, 112);
			this.userControl12.TabIndex = 2;
			// 
			// listBox1
			// 
			this.listBox1.Location = new System.Drawing.Point(232, 176);
			this.listBox1.Name = "listBox1";
			this.listBox1.Size = new System.Drawing.Size(144, 69);
			this.listBox1.TabIndex = 3;
			this.listBox1.SelectedValueChanged += new System.EventHandler(this.ListBox1SelectedValueChanged);
			// 
			// label2
			// 
			this.label2.Font = new System.Drawing.Font("Tahoma", 11F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.World);
			this.label2.Location = new System.Drawing.Point(232, 16);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(112, 23);
			this.label2.TabIndex = 5;
			this.label2.Text = "Libre / total libre";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// userControl11
			// 
			this.userControl11.BackColor = System.Drawing.SystemColors.Control;
			this.userControl11.Location = new System.Drawing.Point(8, 56);
			this.userControl11.Name = "userControl11";
			this.userControl11.Size = new System.Drawing.Size(192, 192);
			this.userControl11.TabIndex = 0;
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Tahoma", 11F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.World);
			this.label1.Location = new System.Drawing.Point(16, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(176, 23);
			this.label1.TabIndex = 4;
			this.label1.Text = "Libre / occup";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(408, 266);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.listBox1);
			this.Controls.Add(this.userControl12);
			this.Controls.Add(this.userControl11);
			this.Name = "MainForm";
			this.Text = "MainForm";
			this.Load += new System.EventHandler(this.MainFormLoad);
			this.ResumeLayout(false);
		}
		#endregion

		
		void MainFormLoad(object sender, System.EventArgs e)
		{
			// stockage des donnes des lecteurs
			foreach (string xxdir in System.IO.Directory.GetLogicalDrives())
			{
				string xlect=xxdir.Replace("\\","");
				// acces par WMI
				string query = "select name, FreeSpace, Size, volumename from win32_logicaldisk where (drivetype=3) and name='"+xlect+"'";
				ManagementObjectSearcher searcher = new ManagementObjectSearcher(query);
   		
				foreach(ManagementObject manobj in searcher.Get()) 
					{
					// lecteur courant
					indlect++;
					tlect[indlect]=xxdir.Replace("\\","");
		    		double freespace2 = double.Parse(manobj["FreeSpace"].ToString());
    				double disksize2 = double.Parse(manobj["Size"].ToString());
    				tfree[indlect]=freespace2;
    				ttotal[indlect]=disksize2;
    				// total general des lecteurs
    				tvolume[indlect]=manobj["volumename"].ToString();
    				listBox1.Items.Add(tlect[indlect]+" - "+tvolume[indlect]);
    				tfree[0]+=freespace2;
    				ttotal[0]+=disksize2;
					}
				}
    
			}
   private int calpct(int i)
   {
		// calcul du % libre / total
		return (int) ((ttotal[i] - tfree[i] )* 100 / ttotal[i]);
   }
   
   void ListBox1SelectedValueChanged(object sender, System.EventArgs e)
   // traitement du lecteur chois dans la listbox
   {
   			int i=listBox1.SelectedIndex+1;
   			userControl11.valeur=calpct(i);
			userControl11.BackColor=Color.FromArgb(255, 200, 255, 240);
			userControl12.valeur=(int) (100 - (tfree[i] * 100 / tfree[0]));
	}
   
     
   
	}
}
