'
' Created by SharpDevelop.
' User: Administrateur
' Date: 03/03/2005
' Time: 20:59
' 
' To change this template use Tools | Options | Coding | Edit Standard Headers.
'
Imports System
Imports System.Data
Imports System.Data.OleDb


Module Main
	Sub Main()
		Dim cnn As OleDbConnection
		Dim oda As OleDbDataAdapter
		Dim opa As OleDbParameter
		Dim ds As dataset
		Dim dr As datarow
		Dim cmd As oledbcommand
		
		Const csinsert="insert into table1 (Kle1, texte1, text2) values(@zcle, @ztxt, @ztx2)"
		Const csupdate="update table1 set text2=@ztx2,texte1=@ztxt where kle1=@zcle"
		Const csdelete="delete from table1 where kle1=@zcle"
		
		' cration connexion
		cnn=New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data source=E:\didier\devnet\bd02vb\bd.mdb")
		cnn.Open()
		
		' cration adaptateur		
		oda=New oledbdataadapter("select * from table1", cnn)
		
		' ... commande d'insertion dans la base
		oda.InsertCommand=New OleDbCommand(csinsert, cnn)
		
		opa=oda.InsertCommand.Parameters.Add("@zcle", oledbtype.Integer)
		opa.SourceColumn="Kle1"
		opa.SourceVersion=datarowversion.Current
		
		opa=oda.InsertCommand.Parameters.Add("@ztxt", oledbtype.VarChar)
		opa.SourceColumn="Texte1"
		opa.SourceVersion=datarowversion.Current
		
		opa=oda.InsertCommand.Parameters.Add("@ztx2", oledbtype.VarChar)
		opa.SourceColumn="Text2"
		opa.SourceVersion=datarowversion.Current
		
		' ... commande de mise  jour dans la base
		oda.updateCommand=New OleDbCommand(csupdate, cnn)
		
		opa=oda.updateCommand.Parameters.Add("@zcle", oledbtype.Integer)
		opa.SourceColumn="Kle1"
		opa.SourceVersion=datarowversion.Original
		
		opa=oda.updateCommand.Parameters.Add("@ztxt", oledbtype.varchar, 50)
		opa.SourceColumn="Texte1"
		opa.SourceVersion=datarowversion.Current
		
		opa=oda.updateCommand.Parameters.Add("@ztx2", oledbtype.VarChar, 50)
		opa.SourceColumn="text2"
		opa.SourceVersion=datarowversion.Current
		
		' ... commande de suppression dans la base
		oda.deleteCommand=New OleDbCommand(csdelete, cnn)
		
		opa=oda.updateCommand.Parameters.Add("@zcle", oledbtype.Integer)
		opa.SourceColumn="Kle1"
		opa.SourceVersion=datarowversion.Original
		
		' suppression de toutes les lignes avant de crer le dataset
		cmd =cnn.CreateCommand()
		cmd.CommandText="delete from table1"
		cmd.ExecuteNonQuery()
		
		'cration du dataset 
		ds=New DataSet()
		oda.MissingSchemaAction=Missingschemaaction.AddWithKey
		oda.Fill(ds,"trav")
		
		' ajout de lignes
		dr=ds.Tables("trav").newrow()
		dr(0)=101
		dr(1)="Texte 101"
		ds.Tables("trav").rows.add(dr)
		
		dr=ds.Tables("trav").newrow()
		dr(0)=50
		dr(1)="Texte 50"
		ds.Tables("trav").rows.add(dr)

		' ... cette ligne n'est pas valide
		dr=ds.Tables("trav").newrow()
		dr(0)=121
		dr(1)="Texte 121"
		ds.Tables("trav").rows.add(dr)

		' 
		dr=ds.Tables("trav").newrow()
		dr(0)=71
		dr(1)="Texte 71"
		dr(2)="abc"
		ds.Tables("trav").rows.add(dr)

		' mise  jour d'une ligne
		dr=ds.Tables("trav").rows.find(50)
		dr.BeginEdit
		dr(1)="Texte 50 modifi"
		dr(2)="t50"
		dr.EndEdit
		
		dr=ds.Tables("trav").rows.find(71)
		dr("text2")="6"
		dr("Texte1")="Texte 50 modifi 2 fois"
		dr("text2")="71"

		' suppression d'une ligne
		dr=ds.Tables("trav").rows.find(121)
		dr.Delete
				
		' validation dans la base relle
		oda.Update(ds,"trav")

		cnn.Close()

		console.Write ("Le dataset contient ")
		console.Write (ds.Tables.Count)
		console.WriteLine (" tables ")
		Dim tt As datatable
		For Each tt In ds.Tables
			console.WriteLine("***   " + tt.tablename)
			console.WriteLine("      "+tt.Rows.Count.ToString+" colonnes")
			Dim cc As datacolumn
			For Each cc In tt.columns
				console.Write("       - ")
				console.WriteLine(cc.ColumnName)
			Next
		Next
		
	End Sub
End Module
